"use strict";
/*
 * Copyright 2018 Dialog LLC <info@dlg.im>
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tls_1 = __importDefault(require("tls"));
const https_1 = __importDefault(require("https"));
const crypto_1 = require("crypto");
const sha256 = (data) => crypto_1.createHash('sha256').update(data).digest('base64');
function fetchSslPinningConfig({ host, port }) {
    return new Promise((resolve, reject) => {
        const req = https_1.default.request({
            host,
            port: parseInt(port, 10) || 443
        }, ({ socket }) => {
            if (socket instanceof tls_1.default.TLSSocket) {
                const cert = socket.getPeerCertificate(true);
                const fingerprints = [];
                for (let issuer = cert; issuer !== issuer.issuerCertificate; issuer = issuer.issuerCertificate) {
                    fingerprints.push('sha256/' + sha256(issuer.raw));
                }
                const domain = cert.subject.CN;
                resolve({ domain, fingerprints });
            }
            else {
                reject(new Error('Unexpected req.socket type'));
            }
        });
        req.once('error', reject);
        req.end();
    });
}
module.exports = fetchSslPinningConfig;
